"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _Webpack = require("./Webpack");

var _Webpack2 = _interopRequireDefault(_Webpack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function () {
  var enterModule = require('react-hot-loader/patch').enterModule;

  enterModule && enterModule(module);
})();

var ReactRoute = function () {
  function ReactRoute(prefix, app, wpClientCfg, wpServerCfg, options, middleware) {
    (0, _classCallCheck3.default)(this, ReactRoute);

    this.prefix = prefix;
    this.app = app;
    this.options = options;
    this.middleware = middleware;

    this.webpack = new _Webpack2.default({ isDevMode: options.isDevMode }, this.parent);
    this.webpack.updateClientConfig(wpClientCfg);
    this.webpack.updateServerConfig(wpServerCfg);

    if (this.prefix.length > 0) {
      var publicPath = _path2.default.posix.join("/", this.prefix, this.webpack.clientConfig.output.publicPath);
      this.webpack.updateClientConfig({ output: { publicPath: publicPath } });
    }

    this.webpack.addVariable({
      NODE_ENV: (0, _stringify2.default)(options.isDevMode ? "development" : "production"),
      REACT_APP_PATH: (0, _stringify2.default)(this.app),
      REACT_ROUTE_PREFIX: (0, _stringify2.default)(_path2.default.posix.join("/", this.prefix))
    });
  }

  (0, _createClass3.default)(ReactRoute, [{
    key: "setHTML",
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(fn) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(typeof fn === "undefined" ? "undefined" : (0, _typeof3.default)(fn)) === "function") {
                  this.parent.logger.warn("[ReactRoute] setHTML(function) - You must pass a function");
                }
                this.webpack.addVariable({ RENDER_HTML_FUNCTION: fn });

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function setHTML(_x) {
        return _ref.apply(this, arguments);
      }

      return setHTML;
    }()
  }, {
    key: "setGraphqlEnpoint",
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(endpoint) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(typeof endpoint === "undefined" ? "undefined" : (0, _typeof3.default)(endpoint)) === "string") {
                  this.parent.logger.warn("[Webpack] setGraphqlEnpoint(function) - You must pass a string");
                }
                this.webpack.addVariable({ GRAPHQL_ENDPOINT: (0, _stringify2.default)(endpoint) });

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function setGraphqlEnpoint(_x2) {
        return _ref2.apply(this, arguments);
      }

      return setGraphqlEnpoint;
    }()
  }, {
    key: "__reactstandin__regenerateByEval",
    value: function __reactstandin__regenerateByEval(key, code) {
      this[key] = eval(code);
    }
  }]);
  return ReactRoute;
}();

var _default = ReactRoute;
exports.default = _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader/patch').default;

  var leaveModule = require('react-hot-loader/patch').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(ReactRoute, "ReactRoute", "src/classes/ReactRoute.js");
  reactHotLoader.register(_default, "default", "src/classes/ReactRoute.js");
  leaveModule(module);
})();

;