"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _koaRouter = require("koa-router");

var _koaRouter2 = _interopRequireDefault(_koaRouter);

var _koaSend = require("koa-send");

var _koaSend2 = _interopRequireDefault(_koaSend);

var _koaStaticServer = require("koa-static-server");

var _koaStaticServer2 = _interopRequireDefault(_koaStaticServer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function () {
  var enterModule = require('react-hot-loader/patch').enterModule;

  enterModule && enterModule(module);
})();

var Router = function () {
  function Router(props, parent) {
    (0, _classCallCheck3.default)(this, Router);

    this.parent = parent;
    this.api = new _koaRouter2.default();
  }

  (0, _createClass3.default)(Router, [{
    key: "addRouteFile",
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(file) {
        var route;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                route = require(file);

                route(this.api, this.parent.app, this.parent.config);
                this.parent.logger.info("[Route] added: " + file);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function addRouteFile(_x) {
        return _ref.apply(this, arguments);
      }

      return addRouteFile;
    }()
  }, {
    key: "addRouteFolder",
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(routeArray) {
        var _this = this;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (routeArray.isArray()) {
                  _context2.next = 3;
                  break;
                }

                this.parent.logger.warn("[Route] addRouteFolder() - the function should contain a array!");
                return _context2.abrupt("return");

              case 3:
                routeArray.map(function (route) {
                  return _this.addRoute(route);
                });

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function addRouteFolder(_x2) {
        return _ref2.apply(this, arguments);
      }

      return addRouteFolder;
    }()
  }, {
    key: "addStaticFile",
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(filePath) {
        var _this2 = this;

        var servePath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
        var isFile;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(!filePath || filePath.length == 0)) {
                  _context4.next = 3;
                  break;
                }

                this.parent.logger.warn("[Router] addStaticFile() - called without a valid file/string.");
                return _context4.abrupt("return");

              case 3:
                _context4.prev = 3;
                isFile = _fs2.default.lstatSync(filePath).isFile();

                if (isFile) {
                  _context4.next = 10;
                  break;
                }

                this.parent.logger.warn("[Router] addStaticFile() - path:" + filePath + " - is not a file");
                return _context4.abrupt("return");

              case 10:
                //send file
                this.parent.app.use(function () {
                  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(ctx, next) {
                    var publicPath;
                    return _regenerator2.default.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            publicPath = servePath == "" ? _path2.default.posix.join("/", _path2.default.basename(filePath)) : _path2.default.posix.join("/", servePath);

                            if (!(ctx.path == publicPath)) {
                              _context3.next = 7;
                              break;
                            }

                            _context3.next = 4;
                            return (0, _koaSend2.default)(ctx, _path2.default.basename(filePath), {
                              root: _path2.default.dirname(filePath)
                            });

                          case 4:
                            return _context3.abrupt("return", next());

                          case 7:
                            return _context3.abrupt("return", next());

                          case 8:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this2);
                  }));

                  return function (_x5, _x6) {
                    return _ref4.apply(this, arguments);
                  };
                }());

              case 11:
                _context4.next = 17;
                break;

              case 13:
                _context4.prev = 13;
                _context4.t0 = _context4["catch"](3);

                this.parent.logger.warn("[Router] addStaticFile()");
                this.parent.logger.warn(_context4.t0);

              case 17:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[3, 13]]);
      }));

      function addStaticFile(_x3) {
        return _ref3.apply(this, arguments);
      }

      return addStaticFile;
    }()
  }, {
    key: "addStaticFolder",
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(filePath, servePath) {
        var isFile, isDirectory;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!(!filePath || filePath.length == 0)) {
                  _context5.next = 3;
                  break;
                }

                this.parent.logger.warn("[Router] addStaticFolder() - called without a valid file/string.");
                return _context5.abrupt("return");

              case 3:
                _context5.prev = 3;
                isFile = _fs2.default.lstatSync(filePath).isFile();
                isDirectory = _fs2.default.lstatSync(filePath).isDirectory();

                if (!(!isFile && !isDirectory)) {
                  _context5.next = 11;
                  break;
                }

                this.parent.logger.warn("[Route] addStaticFolder() - path:" + filePath + " - does not exist");
                return _context5.abrupt("return");

              case 11:
                if (isFile) {
                  this.addStaticFile(filePath);
                } else {
                  this.parent.app.use((0, _koaStaticServer2.default)({ rootDir: filePath, rootPath: servePath }));
                  //host folder
                }

              case 12:
                _context5.next = 18;
                break;

              case 14:
                _context5.prev = 14;
                _context5.t0 = _context5["catch"](3);

                this.parent.logger.warn("[Router] addStaticFile()");
                this.parent.logger.warn(_context5.t0);

              case 18:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this, [[3, 14]]);
      }));

      function addStaticFolder(_x7, _x8) {
        return _ref5.apply(this, arguments);
      }

      return addStaticFolder;
    }()
  }, {
    key: "addRoute",
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(route) {
        var _this3 = this;

        var isFile, isDirectory, files;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (!(!route || route.length == 0)) {
                  _context6.next = 3;
                  break;
                }

                this.parent.logger.warn("[Route] addRoute() - called without a valid file/string.");
                return _context6.abrupt("return");

              case 3:
                route = _path2.default.resolve(process.cwd(), route);
                _context6.prev = 4;
                isFile = _fs2.default.lstatSync(route).isFile();
                isDirectory = _fs2.default.lstatSync(route).isDirectory();

                if (!(!isFile && !isDirectory)) {
                  _context6.next = 12;
                  break;
                }

                this.parent.logger.warn("[Route] addRoute() - path:" + route + " - does not exist");
                return _context6.abrupt("return");

              case 12:
                if (!isFile) {
                  _context6.next = 16;
                  break;
                }

                this.addRouteFile(route);
                _context6.next = 20;
                break;

              case 16:
                _context6.next = 18;
                return _fs2.default.readdirSync(route);

              case 18:
                files = _context6.sent;

                files.forEach(function (file) {
                  return _this3.addRouteFile(_path2.default.resolve(route, file));
                });

              case 20:
                _context6.next = 25;
                break;

              case 22:
                _context6.prev = 22;
                _context6.t0 = _context6["catch"](4);

                this.parent.logger.warn("[Route] addRoutesFolderOrFile() - " + _context6.t0);

              case 25:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this, [[4, 22]]);
      }));

      function addRoute(_x9) {
        return _ref6.apply(this, arguments);
      }

      return addRoute;
    }()
  }, {
    key: "__reactstandin__regenerateByEval",
    value: function __reactstandin__regenerateByEval(key, code) {
      this[key] = eval(code);
    }
  }]);
  return Router;
}();

var _default = Router;
exports.default = _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader/patch').default;

  var leaveModule = require('react-hot-loader/patch').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(Router, "Router", "src/classes/Router.js");
  reactHotLoader.register(_default, "default", "src/classes/Router.js");
  leaveModule(module);
})();

;