"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _koa = require("koa");

var _koa2 = _interopRequireDefault(_koa);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _koaCompress = require("koa-compress");

var _koaCompress2 = _interopRequireDefault(_koaCompress);

var _koaConditionalGet = require("koa-conditional-get");

var _koaConditionalGet2 = _interopRequireDefault(_koaConditionalGet);

var _kcors = require("kcors");

var _kcors2 = _interopRequireDefault(_kcors);

var _koaEtag = require("koa-etag");

var _koaEtag2 = _interopRequireDefault(_koaEtag);

var _koaHelmet = require("koa-helmet");

var _koaHelmet2 = _interopRequireDefault(_koaHelmet);

var _koaJson = require("koa-json");

var _koaJson2 = _interopRequireDefault(_koaJson);

var _koaConvert = require("koa-convert");

var _koaConvert2 = _interopRequireDefault(_koaConvert);

var _koaSend = require("koa-send");

var _koaSend2 = _interopRequireDefault(_koaSend);

var _koaLogger = require("koa-logger");

var _koaLogger2 = _interopRequireDefault(_koaLogger);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _webpack = require("webpack");

var _webpack2 = _interopRequireDefault(_webpack);

var _ddos = require("ddos");

var _ddos2 = _interopRequireDefault(_ddos);

var _Router = require("./Router");

var _Router2 = _interopRequireDefault(_Router);

var _Webpack = require("./Webpack");

var _Webpack2 = _interopRequireDefault(_Webpack);

var _ReactRoute = require("./ReactRoute");

var _ReactRoute2 = _interopRequireDefault(_ReactRoute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function () {
  var enterModule = require('react-hot-loader/patch').enterModule;

  enterModule && enterModule(module);
})();

//
//Handle main Koa2 and webpack for app.
//
var Server = function () {
  function Server(props, parent) {
    (0, _classCallCheck3.default)(this, Server);

    this.parent = parent;
    this.logger = parent.logger;
    this.app = new _koa2.default();
    this.router = new _Router2.default({}, this);

    this.isRunning = false;
    this.SSRRoutes = [];
    this.isDevMode = this.parent.config.environment == "development" ? true : false;
  }

  (0, _createClass3.default)(Server, [{
    key: "addReactRoute",
    value: function addReactRoute(prefix, app, wpClientCfg, wpServerCfg, options, middleware) {
      (0, _assign2.default)(options, { isDevMode: this.isDevMode });

      if (app.length == 0) {
        this.parent.logger.warn("[Route] addReactRoute() - path to <App/> is missing");
        return;
      }

      if (!_fs2.default.lstatSync(app).isFile()) {
        this.parent.logger.warn("[Route] addReactRoute() - path to <App/> does not exist");
        return;
      }

      var route = new _ReactRoute2.default(prefix, app, wpClientCfg, wpServerCfg, options, middleware);

      this.SSRRoutes.push(route);
      return this.SSRRoutes[this.SSRRoutes.length - 1];
    }
  }, {
    key: "renderReactApps",
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var _this = this;

        var webpackDevMiddleware, webpackHotMiddleware, webpackHotServerMiddleware, routes;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!this.isDevMode) {
                  _context3.next = 8;
                  break;
                }

                webpackDevMiddleware = require("webpack-dev-middleware");
                webpackHotMiddleware = require("koa-webpack-hot-middleware");
                webpackHotServerMiddleware = require("webpack-hot-server-middleware");
                _context3.next = 6;
                return this.SSRRoutes.map(function () {
                  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(routeObject) {
                    var compiledConfigs;
                    return _regenerator2.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return routeObject.webpack.compile();

                          case 2:
                            compiledConfigs = _context.sent;
                            _context.next = 5;
                            return _this.app.use(_this.koaDevware(webpackDevMiddleware(compiledConfigs, {
                              serverSideRender: true,
                              publicPath: compiledConfigs.compilers[0].options.output.publicPath,
                              stats: {
                                colors: true,
                                modules: false
                              }
                            })));

                          case 5:
                            _context.next = 7;
                            return _this.app.use((0, _koaConvert2.default)(webpackHotMiddleware(compiledConfigs.compilers[0])));

                          case 7:
                            _context.next = 9;
                            return _this.app.use(webpackHotServerMiddleware(compiledConfigs, {
                              createHandler: webpackHotServerMiddleware.createKoaHandler
                            }));

                          case 9:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, _this);
                  }));

                  return function (_x) {
                    return _ref2.apply(this, arguments);
                  };
                }());

              case 6:
                _context3.next = 13;
                break;

              case 8:
                this.parent.logger.info("[Compile] Getting files ready, this may take a while....");
                _context3.next = 11;
                return this.SSRRoutes.map(function (routeObject) {
                  return new _promise2.default(function (resolve, reject) {
                    var _routeObject$webpack = routeObject.webpack,
                        clientConfig = _routeObject$webpack.clientConfig,
                        serverConfig = _routeObject$webpack.serverConfig;


                    routeObject.webpack.compileWithCallback(function (err, stats) {
                      //host static files and files only
                      stats.toJson().children[0].assets.map(function (asset) {
                        var publicPath = _path2.default.posix.join(clientConfig.output.publicPath, asset.name);
                        _this.app.use(function () {
                          var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(ctx, next) {
                            return _regenerator2.default.wrap(function _callee2$(_context2) {
                              while (1) {
                                switch (_context2.prev = _context2.next) {
                                  case 0:
                                    if (!(ctx.path == publicPath)) {
                                      _context2.next = 5;
                                      break;
                                    }

                                    _context2.next = 3;
                                    return (0, _koaSend2.default)(ctx, asset.name, {
                                      root: clientConfig.output.path
                                    });

                                  case 3:
                                    _context2.next = 6;
                                    break;

                                  case 5:
                                    return _context2.abrupt("return", next());

                                  case 6:
                                  case "end":
                                    return _context2.stop();
                                }
                              }
                            }, _callee2, _this);
                          }));

                          return function (_x2, _x3) {
                            return _ref3.apply(this, arguments);
                          };
                        }());
                      });

                      //render html if route matches..
                      var clientStats = stats.toJson().children[0];
                      var serverStats = stats.toJson().children[1];

                      var serverFile = void 0;
                      serverStats.assets.map(function (file) {
                        if (_path2.default.extname(file.name) == ".js") {
                          serverFile = file.name;
                        }
                      });

                      var serverRender = require(_path2.default.resolve(serverConfig.output.path, serverFile)).default;
                      _this.app.use(serverRender({ clientStats: clientStats }));
                      resolve();
                    });
                  });
                });

              case 11:
                routes = _context3.sent;

                _promise2.default.all(routes);

              case 13:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function renderReactApps() {
        return _ref.apply(this, arguments);
      }

      return renderReactApps;
    }()

    /**
     * Start server
     * @return {[type]} [description]
     */

  }, {
    key: "start",
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.prev = 0;

                if (this.isDevMode) this.parent.logger.info("[Start] Running in development mode!");else this.parent.logger.info("[Start] Running in production mode!");

                if (this.parent.config.environment == "development" && this.parent.config.options && this.parent.config.options.logRequests) this.app.use((0, _koaLogger2.default)());

                _context4.next = 5;
                return this.addKoaMiddleware();

              case 5:
                if (!(this.SSRRoutes.length > 0)) {
                  _context4.next = 8;
                  break;
                }

                _context4.next = 8;
                return this.renderReactApps();

              case 8:

                this.startListen();
                _context4.next = 14;
                break;

              case 11:
                _context4.prev = 11;
                _context4.t0 = _context4["catch"](0);

                this.parent.logger.error("Server start(): " + _context4.t0);

              case 14:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[0, 11]]);
      }));

      function start() {
        return _ref4.apply(this, arguments);
      }

      return start;
    }()

    /**
     * Start listening
     */

  }, {
    key: "startListen",
    value: function startListen() {
      var _this2 = this;

      this.parent.logger.info("Starting server on http://%s:%s <===", this.parent.config.hostname, this.parent.config.port);

      //add routes
      this.app.use(this.router.api.routes());
      this.app.use(this.router.api.allowedMethods());

      //Only start once
      if (!this.isRunning) {
        this.isRunning = !this.isRunning;
        this.app.listen(this.parent.config.port, function () {
          _this2.parent.logger.info();
          _this2.parent.logger.info("==> Server is up at http://%s:%s <===", _this2.parent.config.hostname, _this2.parent.config.port);
          _this2.parent.logger.info();
        });
      }
    }

    /**
     * Handle Koa Development middleware after compile is complete
     * @param  {webpackmiddleware} dev
     * @param  {webpackcompiler} compiler
     * @return {function} Function to be called
     */

  }, {
    key: "koaDevware",
    value: function koaDevware(dev, compiler) {
      var _this3 = this;

      var waitMiddleware = function waitMiddleware() {
        return new _promise2.default(function (resolve, reject) {
          dev.waitUntilValid(function () {
            return resolve(true);
          });
          compiler.plugin("failed", function (error) {
            return reject(error);
          });
        });
      };

      return function () {
        var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(ctx, next) {
          return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _context5.next = 2;
                  return waitMiddleware();

                case 2:
                  _context5.next = 4;
                  return dev(ctx.req, {
                    end: function end(content) {
                      ctx.body = content;
                    },

                    setHeader: ctx.set.bind(ctx),
                    locals: ctx.state
                  }, next);

                case 4:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5, _this3);
        }));

        return function (_x4, _x5) {
          return _ref5.apply(this, arguments);
        };
      }();
    }
  }, {
    key: "addKoaMiddleware",
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                // if (this.parent.config.options && this.parent.config.options.useDdos){
                //   let ddos = new Ddos(this.parent.config.options.ddosOptions)
                //   this.app.use(ddos.koa().bind(ddos))
                // }

                if (this.parent.config.options && this.parent.config.options.useHelmet) this.app.use((0, _koaHelmet2.default)(this.parent.config.options.helmetOptions));

                if (this.parent.config.options && this.parent.config.options.useJsonPretty) this.app.use((0, _koaJson2.default)());

                if (this.parent.config.options && this.parent.config.options.useCompress) this.app.use((0, _koaCompress2.default)(this.parent.config.options.compressOptions));

                if (this.parent.config.options && this.parent.config.options.useCors) this.app.use((0, _kcors2.default)(this.parent.config.options.corsOptions));

                if (this.parent.config.options && this.parent.config.options.useEtags) {
                  this.app.use((0, _koaConditionalGet2.default)());
                  this.app.use((0, _koaEtag2.default)());
                }

              case 5:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function addKoaMiddleware() {
        return _ref6.apply(this, arguments);
      }

      return addKoaMiddleware;
    }()
  }, {
    key: "__reactstandin__regenerateByEval",
    value: function __reactstandin__regenerateByEval(key, code) {
      this[key] = eval(code);
    }
  }]);
  return Server;
}();

var _default = Server;
exports.default = _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader/patch').default;

  var leaveModule = require('react-hot-loader/patch').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(Server, "Server", "src/classes/Server.js");
  reactHotLoader.register(_default, "default", "src/classes/Server.js");
  leaveModule(module);
})();

;