"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _webpack = require("webpack");

var _webpack2 = _interopRequireDefault(_webpack);

var _v = require("uuid/v4");

var _v2 = _interopRequireDefault(_v);

var _webpackMerge = require("webpack-merge");

var _webpackMerge2 = _interopRequireDefault(_webpackMerge);

var _happypack = require("happypack");

var _happypack2 = _interopRequireDefault(_happypack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function () {
  var enterModule = require('react-hot-loader/patch').enterModule;

  enterModule && enterModule(module);
})();

var Webpack = function () {
  function Webpack(props, parent) {
    (0, _classCallCheck3.default)(this, Webpack);

    this.parent = parent;
    this.compileConfigs = [];

    this.variables = {};

    this.externals = [];
    var modulesPath = _path2.default.resolve(process.cwd(), "node_modules");
    if (_fs2.default.existsSync(modulesPath) && _fs2.default.lstatSync(modulesPath).isDirectory()) this.externals = _fs2.default.readdirSync(modulesPath).filter(function (x) {
      return !/\.bin|react-universal-component|webpack-flush-chunks/.test(x);
    }).reduce(function (externals, mod) {
      externals[mod] = "commonjs " + mod;
      return externals;
    }, {});

    this.clientConfig = {
      name: "client",
      target: "web",
      devtool: "eval",
      module: {
        rules: [{
          test: /\.js$/,
          use: "happypack/loader",
          exclude: /node_modules/
        }]
      },
      resolve: {
        extensions: [".js"]
      }
    };

    this.serverConfig = {
      name: "server",
      target: "node",
      devtool: "eval",
      entry: _path2.default.resolve(process.cwd(), "node_modules/extensive-react-server/lib/utils/server-render"),
      module: {
        rules: [{
          test: /\.js$/,
          use: "happypack/loader",
          exclude: /node_modules/
        }]
      },
      resolve: {
        extensions: [".js"]
      }
    };

    if (props.isDevMode) {
      this.setClientConfigDev();
      this.setServerConfigDev();
    } else {
      this.setClientConfigProd();
      this.setServerConfigProd();
    }
  }

  (0, _createClass3.default)(Webpack, [{
    key: "setClientConfigDev",
    value: function setClientConfigDev() {
      this.clientConfig = (0, _webpackMerge2.default)(true, this.clientConfig, {
        entry: ["webpack-hot-middleware/client?path=/__webpack_hmr&timeout=20000&reload=false&quiet=false&noInfo=false", "react-hot-loader/patch", _path2.default.resolve(process.cwd(), "node_modules/extensive-react-server/lib/utils/client-render")],
        output: {
          filename: "[name].js",
          chunkFilename: "[name].js",
          path: _path2.default.resolve(process.cwd(), "build/client"),
          publicPath: "/static/"
        },
        plugins: [new _happypack2.default({
          loaders: [{
            loader: "babel-loader",
            options: {
              babelrc: true,
              comments: true
            }
          }]
        }), new _webpack2.default.HotModuleReplacementPlugin(), new _webpack2.default.NoEmitOnErrorsPlugin()]
      });
    }
  }, {
    key: "setClientConfigProd",
    value: function setClientConfigProd() {
      this.clientConfig = (0, _webpackMerge2.default)(true, this.clientConfig, {
        devtool: "nosources-source-map",
        entry: _path2.default.resolve(process.cwd(), "node_modules/extensive-react-server/lib/utils/client-render"),
        output: {
          filename: "[name].[chunkhash].js",
          chunkFilename: "[name].[chunkhash].js",
          path: _path2.default.resolve(process.cwd(), "build/client"),
          publicPath: "/static/"
        },
        plugins: [new _happypack2.default({
          loaders: [{
            loader: "babel-loader",
            options: {
              babelrc: true,
              comments: true
            }
          }]
        }), new _webpack2.default.optimize.UglifyJsPlugin({
          compress: {
            screw_ie8: true,
            warnings: false
          },
          mangle: {
            screw_ie8: true
          },
          output: {
            screw_ie8: true,
            comments: false
          },
          sourceMap: true
        }), new _webpack2.default.HashedModuleIdsPlugin()]
      });
    }
  }, {
    key: "setServerConfigDev",
    value: function setServerConfigDev() {
      var externals = this.externals;
      this.serverConfig = (0, _webpackMerge2.default)(true, this.serverConfig, {
        externals: externals,
        output: {
          path: _path2.default.resolve(__dirname, "build/ssr"),
          filename: "[name].js",
          libraryTarget: "commonjs2"
        },
        plugins: [new _happypack2.default({
          loaders: [{
            loader: "babel-loader",
            options: {
              babelrc: true,
              comments: true
            }
          }]
        }), new _webpack2.default.optimize.LimitChunkCountPlugin({
          maxChunks: 1
        })]
      });
    }
  }, {
    key: "setServerConfigProd",
    value: function setServerConfigProd() {
      this.serverConfig = (0, _webpackMerge2.default)(true, this.serverConfig, {
        devtool: "source-map",
        output: {
          path: _path2.default.resolve(process.cwd(), "build/ssr"),
          filename: "[name].[chunkhash].js",
          chunkFilename: "[name].[chunkhash].js",
          libraryTarget: "commonjs2"
        },
        plugins: [new _happypack2.default({
          loaders: [{
            loader: "babel-loader",
            options: {
              babelrc: true,
              comments: true
            }
          }]
        }), new _webpack2.default.optimize.LimitChunkCountPlugin({
          maxChunks: 1
        })]
      });
    }

    /**
     * [updateClientConfig description]
     * @param  {[type]} cfg [description]
     * @return {[type]}     [description]
     */

  }, {
    key: "updateClientConfig",
    value: function updateClientConfig() {
      var cfg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var strategy = {};
      if (cfg.entry && cfg.entry.length > 0) {
        strategy.entry = "replace";
      }
      this.clientConfig = _webpackMerge2.default.strategy(strategy)(this.clientConfig, cfg);
    }

    /**
     * [updateServerConfig description]
     * @param  {[type]} cfg [description]
     * @return {[type]}     [description]
     */

  }, {
    key: "updateServerConfig",
    value: function updateServerConfig() {
      var cfg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var strategy = {};
      if (cfg.entry && cfg.entry.length > 0) {
        strategy.entry = "replace";
      }
      this.serverConfig = _webpackMerge2.default.strategy(strategy)(this.serverConfig, cfg);
    }

    /**
     * [addToCompile description]
     * @param {[type]} cfg [description]
     */

  }, {
    key: "addToCompile",
    value: function addToCompile() {
      var cfg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      this.compileConfigs.push(cfg);
      return this.compileConfigs.length - 1;
    }

    /**
     * [updateConfigWithStrategy description]
     * @param  {[type]} strategy [description]
     * @param  {[type]} config   [description]
     * @return {[type]}          [description]
     */

  }, {
    key: "updateConfigWithStrategy",
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(strategy, config) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(typeof strategy === "undefined" ? "undefined" : (0, _typeof3.default)(strategy)) === "object" || !(typeof config === "undefined" ? "undefined" : (0, _typeof3.default)(config)) === "object") {
                  this.parent.logger.warn("[Webpack] updateConfigWithStrategy(strategy, object) - You must pass a object");
                }
                this.updateServerConfigWithStrategy(strategy, config);
                this.updateClientConfigWithStrategy(strategy, config);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateConfigWithStrategy(_x4, _x5) {
        return _ref.apply(this, arguments);
      }

      return updateConfigWithStrategy;
    }()

    /**
     * [updateServerConfigWithStrategy description]
     * @param  {[type]} strategy [description]
     * @param  {[type]} config   [description]
     * @return {[type]}          [description]
     */

  }, {
    key: "updateServerConfigWithStrategy",
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(strategy, config) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(typeof strategy === "undefined" ? "undefined" : (0, _typeof3.default)(strategy)) === "object" || !(typeof config === "undefined" ? "undefined" : (0, _typeof3.default)(config)) === "object") {
                  this.parent.logger.warn("[Webpack] updateServerConfigWithStrategy(strategy, object) - You must pass a object");
                }
                this.serverConfig = _webpackMerge2.default.strategy(strategy)(this.serverConfig, config);

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function updateServerConfigWithStrategy(_x6, _x7) {
        return _ref2.apply(this, arguments);
      }

      return updateServerConfigWithStrategy;
    }()

    /**
     * [updateClientConfigWithStrategy description]
     * @param  {[type]} strategy [description]
     * @param  {[type]} config   [description]
     * @return {[type]}          [description]
     */

  }, {
    key: "updateClientConfigWithStrategy",
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var strategy = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(typeof strategy === "undefined" ? "undefined" : (0, _typeof3.default)(strategy)) === "object" || !(typeof config === "undefined" ? "undefined" : (0, _typeof3.default)(config)) === "object") {
                  this.parent.logger.warn("[Webpack] updateClientConfigWithStrategy(strategy, object) - You must pass a object");
                }
                this.clientConfig = _webpackMerge2.default.strategy(strategy)(this.clientConfig, config);

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function updateClientConfigWithStrategy() {
        return _ref3.apply(this, arguments);
      }

      return updateClientConfigWithStrategy;
    }()

    /**
     * Add webpack module bundler
     * @param {object} config [description]
     */

  }, {
    key: "addPlugin",
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(typeof config === "undefined" ? "undefined" : (0, _typeof3.default)(config)) === "object") {
                  this.parent.logger.warn("[Webpack] addPlugin(object) - You must pass a object");
                }
                this.updateConfigWithStrategy({ plugins: "append" }, { plugins: [config] });

              case 2:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function addPlugin() {
        return _ref4.apply(this, arguments);
      }

      return addPlugin;
    }()

    /**
     * [addPlugins description]
     * @param {[type]} config [description]
     */

  }, {
    key: "addPlugins",
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var _this = this;

        var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!config.isArray) {
                  this.parent.logger.warn("[Webpack] addPlugins(array) - You must pass an array");
                }
                configs.map(function (config) {
                  return _this.addPlugin(config);
                });

              case 2:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function addPlugins() {
        return _ref5.apply(this, arguments);
      }

      return addPlugins;
    }()

    /**
     * [addModule description]
     * @param {object} config [description]
     */

  }, {
    key: "addModule",
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (!(typeof config === "undefined" ? "undefined" : (0, _typeof3.default)(config)) === "object") {
                  this.parent.logger.warn("[Webpack] addModule(object) - You must pass a object");
                }
                this.updateConfigWithStrategy({ "module.rules": "append" }, { module: { rules: [config] } });

              case 2:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function addModule() {
        return _ref6.apply(this, arguments);
      }

      return addModule;
    }()

    /**
     * [addModules description]
     * @param {[type]} configs [description]
     */

  }, {
    key: "addModules",
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
        var _this2 = this;

        var configs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                if (!config.isArray) {
                  this.parent.logger.warn("[Webpack] addModules(array) - You must pass an array");
                }
                configs.map(function (config) {
                  return _this2.addModule(config);
                });

              case 2:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function addModules() {
        return _ref7.apply(this, arguments);
      }

      return addModules;
    }()

    /**
     * [addVariables description]
     * @param {[type]} obj [description]
     */

  }, {
    key: "addVariables",
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8() {
        var _this3 = this;

        var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (!array.isArray) {
                  this.parent.logger.warn("[Webpack] addVariables(array) - You must pass an array");
                }
                array.map(function (cfg) {
                  return _this3.addVariable(cfg);
                });

              case 2:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function addVariables() {
        return _ref8.apply(this, arguments);
      }

      return addVariables;
    }()

    /**
     * [addVariable description]
     * @param {[type]} obj [description]
     */

  }, {
    key: "addVariable",
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9() {
        var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                if (!(typeof obj === "undefined" ? "undefined" : (0, _typeof3.default)(obj)) === "object") {
                  this.parent.logger.warn("[Webpack] addVariable(object) - You must pass a object");
                }
                (0, _assign2.default)(this.variables, obj);

              case 2:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function addVariable() {
        return _ref9.apply(this, arguments);
      }

      return addVariable;
    }()

    /**
     * [addExtention description]
     * @param {[type]} obj [description]
     */

  }, {
    key: "addExtention",
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(string) {
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                if (!(typeof string === "undefined" ? "undefined" : (0, _typeof3.default)(string)) === "string") {
                  this.parent.logger.warn("[Webpack] addExtention(string) - You must pass a string");
                }
                this.clientConfig.resolve.extensions = _lodash2.default.union(this.clientConfig.resolve.extensions, [string]);
                this.serverConfig.resolve.extensions = _lodash2.default.union(this.serverConfig.resolve.extensions, [string]);

              case 3:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function addExtention(_x16) {
        return _ref10.apply(this, arguments);
      }

      return addExtention;
    }()
  }, {
    key: "compileVariables",
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11() {
        var variables;
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                variables = {
                  "process.env": this.variables
                };

                this.updateConfigWithStrategy({ plugins: "append" }, { plugins: [new _webpack2.default.DefinePlugin(variables)] });

              case 2:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function compileVariables() {
        return _ref11.apply(this, arguments);
      }

      return compileVariables;
    }()

    /**
     * [compile description]
     * @return {[type]} [description]
     */

  }, {
    key: "compile",
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12() {
        var compile;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.compileVariables();

              case 2:
                _context12.next = 4;
                return this.updateClientConfig({
                  name: this.clientConfig.name + "-" + (0, _v2.default)()
                });

              case 4:
                _context12.next = 6;
                return this.updateServerConfig({
                  name: this.serverConfig.name + "-" + (0, _v2.default)()
                });

              case 6:
                _context12.next = 8;
                return (0, _webpack2.default)([this.clientConfig, this.serverConfig]);

              case 8:
                compile = _context12.sent;
                return _context12.abrupt("return", compile);

              case 10:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function compile() {
        return _ref12.apply(this, arguments);
      }

      return compile;
    }()

    /**
     * [compileWithCallback description]
     * @param  {Function} callback [description]
     * @return {[type]}            [description]
     */

  }, {
    key: "compileWithCallback",
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee13(callback) {
        var compile;
        return _regenerator2.default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return this.compileVariables();

              case 2:
                _context13.next = 4;
                return this.updateClientConfig({
                  name: this.clientConfig.name + "-" + (0, _v2.default)()
                });

              case 4:
                _context13.next = 6;
                return this.updateServerConfig({
                  name: this.serverConfig.name + "-" + (0, _v2.default)()
                });

              case 6:
                _context13.next = 8;
                return (0, _webpack2.default)([this.clientConfig, this.serverConfig]).run(callback);

              case 8:
                compile = _context13.sent;
                return _context13.abrupt("return", compile);

              case 10:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function compileWithCallback(_x17) {
        return _ref13.apply(this, arguments);
      }

      return compileWithCallback;
    }()
  }, {
    key: "__reactstandin__regenerateByEval",
    value: function __reactstandin__regenerateByEval(key, code) {
      this[key] = eval(code);
    }
  }]);
  return Webpack;
}();

var _default = Webpack;
exports.default = _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader/patch').default;

  var leaveModule = require('react-hot-loader/patch').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(Webpack, "Webpack", "src/classes/Webpack.js");
  reactHotLoader.register(_default, "default", "src/classes/Webpack.js");
  leaveModule(module);
})();

;