"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClientRouter = exports.render = exports.historyMiddlewares = undefined;

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var createClientRouter = exports.createClientRouter = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(resolver) {
    var historyProtocol, Router;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            historyProtocol = new _BrowserProtocol2.default();
            _context.next = 3;
            return (0, _createInitialFarceRouter2.default)({
              historyProtocol: historyProtocol,
              historyMiddlewares: historyMiddlewares,
              routeConfig: require(process.env.REACT_APP_PATH).default,
              resolver: resolver,
              render: render
            });

          case 3:
            Router = _context.sent;
            return _context.abrupt("return", Router);

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function createClientRouter(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.createResolver = createResolver;
exports.createClientResolver = createClientResolver;

var _BrowserProtocol = require("farce/lib/BrowserProtocol");

var _BrowserProtocol2 = _interopRequireDefault(_BrowserProtocol);

var _queryMiddleware = require("farce/lib/queryMiddleware");

var _queryMiddleware2 = _interopRequireDefault(_queryMiddleware);

var _createBasenameMiddleware = require("farce/lib/createBasenameMiddleware");

var _createBasenameMiddleware2 = _interopRequireDefault(_createBasenameMiddleware);

var _createInitialFarceRouter = require("found/lib/createInitialFarceRouter");

var _createInitialFarceRouter2 = _interopRequireDefault(_createInitialFarceRouter);

var _createRender = require("found/lib/createRender");

var _createRender2 = _interopRequireDefault(_createRender);

var _foundRelay = require("found-relay");

var _relayRuntime = require("relay-runtime");

var _fetcher = require("./fetcher");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function () {
  var enterModule = require('react-hot-loader/patch').enterModule;

  enterModule && enterModule(module);
})();

var basenameMiddleware = (0, _createBasenameMiddleware2.default)({
  basename: process.env.REACT_ROUTE_PREFIX
});

var historyMiddlewares = exports.historyMiddlewares = [_queryMiddleware2.default, basenameMiddleware];

function createResolver(fetcher) {
  var environment = new _relayRuntime.Environment({
    network: _relayRuntime.Network.create(function () {
      return fetcher.fetch.apply(fetcher, arguments);
    }),
    store: new _relayRuntime.Store(new _relayRuntime.RecordSource())
  });

  return new _foundRelay.Resolver(environment);
}

var render = exports.render = (0, _createRender2.default)({});

function createClientResolver() {
  var fetcher = new _fetcher.ClientFetcher(process.env.GRAPHQL_ENDPOINT, window.__RELAY_PAYLOADS__);
  return createResolver(fetcher);
}

;

(function () {
  var reactHotLoader = require('react-hot-loader/patch').default;

  var leaveModule = require('react-hot-loader/patch').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(basenameMiddleware, "basenameMiddleware", "src/utils/Router.js");
  reactHotLoader.register(historyMiddlewares, "historyMiddlewares", "src/utils/Router.js");
  reactHotLoader.register(createResolver, "createResolver", "src/utils/Router.js");
  reactHotLoader.register(render, "render", "src/utils/Router.js");
  reactHotLoader.register(createClientResolver, "createClientResolver", "src/utils/Router.js");
  reactHotLoader.register(createClientRouter, "createClientRouter", "src/utils/Router.js");
  leaveModule(module);
})();

;