"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _server = require("react-dom/server");

var _server2 = _interopRequireDefault(_server);

var _server3 = require("react-universal-component/server");

var _webpackFlushChunks = require("webpack-flush-chunks");

var _webpackFlushChunks2 = _interopRequireDefault(_webpackFlushChunks);

var _server4 = require("found/lib/server");

var _RedirectException = require("found/lib/RedirectException");

var _RedirectException2 = _interopRequireDefault(_RedirectException);

var _serializeJavascript = require("serialize-javascript");

var _serializeJavascript2 = _interopRequireDefault(_serializeJavascript);

var _reactHelmet = require("react-helmet");

var _fetcher = require("./fetcher");

var _Router = require("./Router");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function () {
  var enterModule = require('react-hot-loader/patch').enterModule;

  enterModule && enterModule(module);
})();

var renderHtml = function renderHtml(_ref) {
  var element = _ref.element,
      clientStats = _ref.clientStats,
      relayPayload = _ref.relayPayload;

  var app = _server2.default.renderToString(element);

  var _flushChunks = (0, _webpackFlushChunks2.default)(clientStats, {
    chunkNames: (0, _server3.flushChunkNames)()
  }),
      js = _flushChunks.js;

  var helmet = _reactHelmet.Helmet.renderStatic();
  var title = helmet && helmet.title && helmet.title.toString();
  var meta = helmet && helmet.meta && helmet.meta.toString();

  return "\n    <!DOCTYPE html>\n    <html>\n\n      <head>\n        <meta charset=\"utf-8\">\n        <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">\n        " + helmet.title.toString() + "\n        " + helmet.meta.toString() + "\n        " + helmet.link.toString() + "\n        <script>window.__RELAY_PAYLOADS__ = " + relayPayload + ";</script>\n      </head>\n\n      <body " + helmet.bodyAttributes.toString() + ">\n        <div id=\"root\">" + app + "</div>\n        " + js + "\n      </body>\n\n    </html>";
};

var _default = function _default(_ref2) {
  var clientStats = _ref2.clientStats;
  return function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx, next) {
      var fetcher, _ref4, redirect, status, element, relayPayload;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;

              if (!(process.env.REACT_ROUTE_PREFIX.length > 0 && !ctx.url.startsWith(process.env.REACT_ROUTE_PREFIX))) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return", next());

            case 3:
              fetcher = new _fetcher.ServerFetcher(process.env.GRAPHQL_ENDPOINT);
              _context.next = 6;
              return (0, _server4.getFarceResult)({
                url: ctx.url,
                historyMiddlewares: _Router.historyMiddlewares,
                routeConfig: require(process.env.REACT_APP_PATH).default,
                resolver: (0, _Router.createResolver)(fetcher),
                render: _Router.render
              });

            case 6:
              _ref4 = _context.sent;
              redirect = _ref4.redirect;
              status = _ref4.status;
              element = _ref4.element;


              if (process.env.GRAPHQL_ENDPOINT !== undefined) relayPayload = (0, _serializeJavascript2.default)(fetcher, { isJSON: true });else relayPayload = null;

              if (!(status !== 200)) {
                _context.next = 13;
                break;
              }

              return _context.abrupt("return", next());

            case 13:
              _context.next = 18;
              break;

            case 15:
              _context.prev = 15;
              _context.t0 = _context["catch"](0);
              return _context.abrupt("return", next());

            case 18:

              ctx.status = 200;

              // Use custom render function if passed
              if (typeof RENDER_HTML_FUNCTION !== "undefined") ctx.body = RENDER_HTML_FUNCTION({ element: element, clientStats: clientStats, relayPayload: relayPayload });else ctx.body = renderHtml({ element: element, clientStats: clientStats, relayPayload: relayPayload });

              next();

            case 21:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, undefined, [[0, 15]]);
    }));

    return function (_x, _x2) {
      return _ref3.apply(this, arguments);
    };
  }();
};

exports.default = _default;
;

(function () {
  var reactHotLoader = require('react-hot-loader/patch').default;

  var leaveModule = require('react-hot-loader/patch').leaveModule;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(renderHtml, "renderHtml", "src/utils/server-render.js");
  reactHotLoader.register(_default, "default", "src/utils/server-render.js");
  leaveModule(module);
})();

;